using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace WindowsProxy
{
    public partial class FormFiltros : Form
    {
        public FormFiltros()
        {
            InitializeComponent();
        }

        String puerto;
        String idioma;
        String userAgent;
        String acceptLanguage;
        String convertirPG;
        String convertirGP;
        String convertirHex;
        String filtrarUA;
        String filtrarAL;
        String proxy;
        String activarProxy;
        String param;
        List<string> extensiones;
        List<string> urls;

        public String Proxy
        {
            get { return proxy; }
            set { proxy = value; }
        }

        public String ActivarProxy
        {
            get { return activarProxy; }
            set { activarProxy = value; }
        }

        public String ConvertirHex
        {
            get { return convertirHex; }
            set { convertirHex = value; }
        }

        public String Param
        {
            get { return param; }
            set { param = value; }
        }

        public String UserAgent
        {
            get { return userAgent; }
            set { userAgent = value; }
        }

        public String AcceptLanguage
        {
            get { return acceptLanguage; }
            set { acceptLanguage = value; }
        }

        public String ConvertirPG
        {
            get { return convertirPG; }
            set { convertirPG = value; }
        }

        public String ConvertirGP
        {
            get { return convertirGP; }
            set { convertirGP = value; }
        }

        public String FiltrarUA
        {
            get { return filtrarUA; }
            set { filtrarUA = value; }
        }

        public String FiltrarAL
        {
            get { return filtrarAL; }
            set { filtrarAL = value; }
        }

        public List<string> Urls
        {
            get { return urls; }
            set { urls = value; }
        }

        public List<string> Extensiones
        {
            get { return extensiones; }
            set { extensiones = value; }
        }

        public String Idioma
        {
            get { return idioma; }
            set { idioma = value; }
        }

        public String Puerto
        {
            get { return puerto; }
            set { puerto = value; }
        }

        private void bVolver_Click(object sender, EventArgs e)
        {
            // borramos el fichero y lo volvemos a crear
            try { File.Delete("config.xml"); }
            catch { }

            if (cConvertirPG.Checked == true) convertirPG = "yes";
            else convertirPG = "no";
            if (cConvertirGP.Checked == true) convertirGP = "yes";
            else convertirGP = "no";
            if (cConvertirHex.Checked == true) convertirHex = "yes";
            else convertirHex = "no";
            if (cFiltrarUA.Checked == true) filtrarUA = "yes";
            else filtrarUA = "no";
            if (cFiltrarAL.Checked == true) filtrarAL = "yes";
            else filtrarAL = "no";

            XmlTextWriter f = new XmlTextWriter("config.xml", new System.Text.ASCIIEncoding());
            f.Formatting = Formatting.Indented;
            f.WriteStartDocument();
            f.WriteStartElement("configuracion");
            f.WriteElementString("puerto", puerto);
            f.WriteElementString("idioma", idioma);
            f.WriteElementString("user-agent", cUserAgent.Text);
            f.WriteElementString("accept-language", cAcceptLanguage.Text);
            f.WriteElementString("convertirPG", convertirPG);
            f.WriteElementString("convertirGP", convertirGP);
            f.WriteElementString("convertirHex", convertirHex);
            f.WriteElementString("filtrarUA", filtrarUA);
            f.WriteElementString("filtrarAL", filtrarAL);
            f.WriteElementString("proxy", proxy);
            f.WriteElementString("activarProxy", activarProxy);
            f.WriteElementString("GPparams", cParametros.Text);
            f.WriteStartElement("extensiones");

            foreach (string extension in extensiones)
                f.WriteElementString("extension", extension);

            f.WriteEndElement();

            f.WriteStartElement("urls");

            foreach (string url in urls)
                f.WriteElementString("url", url);

            f.WriteEndElement();
            f.WriteEndDocument();
            f.Close();

            Puerto = cUserAgent.Text;

            Close();
        }

        private void FormFiltros_Load(object sender, EventArgs e)
        {
            cUserAgent.Text = userAgent;
            cAcceptLanguage.Text = acceptLanguage;

            if (filtrarUA == "yes")
            {
                cFiltrarUA.Checked = true;
                cUserAgent.Enabled = true;
            }
            else
            {
                cFiltrarUA.Checked = false;
                cUserAgent.Enabled = false;
            }

            if (filtrarAL == "yes")
            {
                cFiltrarAL.Checked = true;
                cAcceptLanguage.Enabled = true;
            }
            else
            {
                cFiltrarAL.Checked = false;
                cAcceptLanguage.Enabled = false;
            }

            if (convertirPG == "yes") cConvertirPG.Checked = true;
            else cConvertirPG.Checked = false;

            if (convertirGP == "yes") cConvertirGP.Checked = true;
            else cConvertirGP.Checked = false;

            if (cConvertirGP.Checked == true)
                cParametros.Text = param;
            else
            {
                cParametros.Text = "Todos";
                cParametros.Enabled = false;
            }

            if (convertirHex == "yes") cConvertirHex.Checked = true;
            else cConvertirHex.Checked = false;

            ConfiguraIdioma();
        }

        private void cPuerto_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
                bVolver_Click(sender, e);
        }

        private void ConfiguraIdioma()
        {
            if (Idioma == "es")
            {
                this.Text = "Configurar filtros";
                label2.Text = "(vaco no modifica)";
                bVolver.Text = "VOLVER";
                cConvertirPG.Text = "Convertir POST a GET";
                cConvertirGP.Text = "Convertir GET a POST";
                label3.Text = "parmetros";
                cFiltrarUA.Text = "filtrar";
                cFiltrarAL.Text = "filtrar";
                cConvertirHex.Text = "Convertir ASCII a HEX";
                label4.Text = "(convierte los parmetros entrecomillados a HEX. Por ejemplo:";
                label5.Text = "buscar.php?id='palabra' -> buscar.php?id=0x70616c61627261 )";
            }
            else
            {
                this.Text = "Configure filters";
                label2.Text = "(empty for not modify)";
                bVolver.Text = "BACK";
                cConvertirPG.Text = "Convert POST to GET";
                cConvertirGP.Text = "Convert GET to POST";
                label3.Text = "parameters";
                cFiltrarUA.Text = "filter";
                cFiltrarAL.Text = "filter";
                cConvertirHex.Text = "Convert ASCII to HEX";
                label4.Text = "(convert params with quotes to HEX. For example:";
                label5.Text = "search.php?id='word' -> search.php?id=0x776f7264 )";
            }
        }

        private void cConvertirGP_CheckedChanged(object sender, EventArgs e)
        {
            if (cConvertirGP.Checked == true)
                cParametros.Enabled = true;
            else
            {
                cParametros.Text = "Todos";
                cParametros.Enabled = false;
            }
        }

        private void cfiltrarUA_CheckedChanged(object sender, EventArgs e)
        {
            if (cFiltrarUA.Checked) cUserAgent.Enabled = true;
            else cUserAgent.Enabled = false;
        }

        private void cFiltrarAL_CheckedChanged(object sender, EventArgs e)
        {
            if (cFiltrarAL.Checked) cAcceptLanguage.Enabled = true;
            else cAcceptLanguage.Enabled = false;
        }
    }
}