using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace WindowsProxy
{
    public partial class FormProxy : Form
    {
        public FormProxy()
        {
            InitializeComponent();
        }

        String puerto;
        String idioma;
        String userAgent;
        String acceptLanguage;
        String convertirPG;
        String convertirGP;
        String convertirHex;
        String filtrarUA;
        String filtrarAL;
        String proxy;
        String activarProxy;
        String param;
        List<string> extensiones;
        List<string> urls;

        public String Proxy
        {
            get { return proxy; }
            set { proxy = value; }
        }

        public String ActivarProxy
        {
            get { return activarProxy; }
            set { activarProxy = value; }
        }

        public String ConvertirHex
        {
            get { return convertirHex; }
            set { convertirHex = value; }
        }

        public String Param
        {
            get { return param; }
            set { param = value; }
        }

        public String UserAgent
        {
            get { return userAgent; }
            set { userAgent = value; }
        }

        public String AcceptLanguage
        {
            get { return acceptLanguage; }
            set { acceptLanguage = value; }
        }

        public String ConvertirPG
        {
            get { return convertirPG; }
            set { convertirPG = value; }
        }

        public String ConvertirGP
        {
            get { return convertirGP; }
            set { convertirGP = value; }
        }

        public String FiltrarUA
        {
            get { return filtrarUA; }
            set { filtrarUA = value; }
        }

        public String FiltrarAL
        {
            get { return filtrarAL; }
            set { filtrarAL = value; }
        }

        public List<string> Urls
        {
            get { return urls; }
            set { urls = value; }
        }

        public List<string> Extensiones
        {
            get { return extensiones; }
            set { extensiones = value; }
        }

        public String Idioma
        {
            get { return idioma; }
            set { idioma = value; }
        }

        public String Puerto
        {
            get { return puerto; }
            set { puerto = value; }
        }

        private void bVolver_Click(object sender, EventArgs e)
        {
            if (cHost.Text.Contains(":"))
            {
                try { File.Delete("config.xml"); }
                catch { }

                if (cProxy.Checked == true) activarProxy = "yes";
                else activarProxy = "no";

                XmlTextWriter f = new XmlTextWriter("config.xml", new System.Text.ASCIIEncoding());
                f.Formatting = Formatting.Indented;
                f.WriteStartDocument();
                f.WriteStartElement("configuracion");
                f.WriteElementString("puerto", puerto);
                f.WriteElementString("idioma", idioma);
                f.WriteElementString("user-agent", userAgent);
                f.WriteElementString("accept-language", acceptLanguage);
                f.WriteElementString("convertirPG", convertirPG);
                f.WriteElementString("convertirGP", convertirGP);
                f.WriteElementString("convertirHex", convertirHex);
                f.WriteElementString("filtrarUA", filtrarUA);
                f.WriteElementString("filtrarAL", filtrarAL);
                f.WriteElementString("proxy", cHost.Text);
                f.WriteElementString("activarProxy", activarProxy);
                f.WriteElementString("GPparams", param);
                f.WriteStartElement("extensiones");

                foreach (string extension in extensiones)
                    f.WriteElementString("extension", extension);

                f.WriteEndElement();

                f.WriteStartElement("urls");

                foreach (string url in urls)
                    f.WriteElementString("url", url);

                f.WriteEndElement();
                f.WriteEndDocument();
                f.Close();

                Close();
            }
            else
            {
                if (idioma == "es")
                    MessageBox.Show("Proxy incorrecto. Recuerda escribir IP:puerto", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                else
                    MessageBox.Show("Proxy not correct. Remember to write IP:port", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void FormProxy_Load(object sender, EventArgs e)
        {
            cHost.Text = proxy;

            if (activarProxy == "yes")
            {
                cProxy.Checked = true;
                cHost.Enabled = true;
            }
            else
            {
                cProxy.Checked = false;
                cHost.Enabled = false;
            }

            ConfiguraIdioma();
        }

        private void cIdioma_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
                bVolver_Click(sender, e);
        }

        private void ConfiguraIdioma()
        {
            if (Idioma == "es")
            {
                this.Text = "Configurar Proxy";
                cProxy.Text = "Usar proxy:";
                label1.Text = "(ip:puerto -> ej: 127.0.0.1:8080)";
                bVolver.Text = "VOLVER";
            }
            else
            {
                this.Text = "Configure Proxy";
                cProxy.Text = "Use proxy:";
                label1.Text = "(ip:port -> ex: 127.0.0.1:8080)";
                bVolver.Text = "BACK";
            }
        }

        private void cProxy_CheckedChanged(object sender, EventArgs e)
        {
            if (cProxy.Checked) cHost.Enabled = true;
            else cHost.Enabled = false;
        }
    }
}