using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;

namespace WindowsProxy
{
    public partial class FormUrls : Form
    {
        public FormUrls()
        {
            InitializeComponent();
        }

        String puerto;
        String idioma;
        String userAgent;
        String acceptLanguage;
        String convertirPG;
        String convertirGP;
        String convertirHex;
        String filtrarUA;
        String filtrarAL;
        String proxy;
        String activarProxy;
        String param;
        List<string> extensiones;
        List<string> urls;

        public String Proxy
        {
            get { return proxy; }
            set { proxy = value; }
        }

        public String ActivarProxy
        {
            get { return activarProxy; }
            set { activarProxy = value; }
        }

        public String ConvertirHex
        {
            get { return convertirHex; }
            set { convertirHex = value; }
        }

        public String Param
        {
            get { return param; }
            set { param = value; }
        }

        public String UserAgent
        {
            get { return userAgent; }
            set { userAgent = value; }
        }

        public String AcceptLanguage
        {
            get { return acceptLanguage; }
            set { acceptLanguage = value; }
        }

        public String ConvertirPG
        {
            get { return convertirPG; }
            set { convertirPG = value; }
        }

        public String ConvertirGP
        {
            get { return convertirGP; }
            set { convertirGP = value; }
        }

        public String FiltrarUA
        {
            get { return filtrarUA; }
            set { filtrarUA = value; }
        }

        public String FiltrarAL
        {
            get { return filtrarAL; }
            set { filtrarAL = value; }
        }

        public List<string> Urls
        {
            get { return urls; }
            set { urls = value; }
        }

        public List<string> Extensiones
        {
            get { return extensiones; }
            set { extensiones = value; }
        }

        public String Idioma
        {
            get { return idioma; }
            set { idioma = value; }
        }

        public String Puerto
        {
            get { return puerto; }
            set { puerto = value; }
        }

        private void bVolver_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void bAnadir_Click(object sender, EventArgs e)
        {
            if (cUrl.Text == "")
            {
                if (idioma == "es")
                    MessageBox.Show("Debes escribir una url", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                else
                    MessageBox.Show("You have to write any url", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
            {
                if (!cUrl.Text.Contains("http://")) cUrl.Text = "http://" + cUrl.Text;

                try { File.Delete("config.xml"); }
                catch { }

                XmlTextWriter f = new XmlTextWriter("config.xml", new System.Text.ASCIIEncoding());
                f.Formatting = Formatting.Indented;
                f.WriteStartDocument();
                f.WriteStartElement("configuracion");
                f.WriteElementString("puerto", puerto);
                f.WriteElementString("idioma", idioma);
                f.WriteElementString("user-agent", userAgent);
                f.WriteElementString("accept-language", acceptLanguage);
                f.WriteElementString("convertirPG", convertirPG);
                f.WriteElementString("convertirGP", convertirGP);
                f.WriteElementString("convertirHex", convertirHex);
                f.WriteElementString("filtrarUA", filtrarUA);
                f.WriteElementString("filtrarAL", filtrarAL);
                f.WriteElementString("proxy", proxy);
                f.WriteElementString("activarProxy", activarProxy);
                f.WriteElementString("GPparams", param);
                f.WriteStartElement("extensiones");

                foreach (string extension in extensiones)
                    f.WriteElementString("extension", extension);

                f.WriteEndElement();

                f.WriteStartElement("urls");

                foreach (string url in cUrls.Items)
                    f.WriteElementString("url", url);

                f.WriteElementString("url", cUrl.Text);
                f.WriteEndElement();
                f.WriteEndDocument();
                f.Close();

                cUrl.Text = "";

                leerConfiguracion();
            }
        }

        private void bEliminar_Click(object sender, EventArgs e)
        {
            if (cUrls.Text == "")
            {
                if (idioma == "es")
                    MessageBox.Show("Debes seleccionar una url", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                else
                    MessageBox.Show("You have to select a url", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else
            {
                String ext = cUrls.Text;

                try { File.Delete("config.xml"); }
                catch { }

                XmlTextWriter f = new XmlTextWriter("config.xml", new System.Text.ASCIIEncoding());
                f.Formatting = Formatting.Indented;
                f.WriteStartDocument();
                f.WriteStartElement("configuracion");
                f.WriteElementString("puerto", puerto);
                f.WriteElementString("idioma", idioma);
                f.WriteElementString("user-agent", userAgent);
                f.WriteElementString("accept-language", acceptLanguage);
                f.WriteElementString("convertirPG", convertirPG);
                f.WriteElementString("convertirGP", convertirGP);
                f.WriteElementString("convertirHex", convertirHex);
                f.WriteElementString("filtrarUA", filtrarUA);
                f.WriteElementString("filtrarAL", filtrarAL);
                f.WriteElementString("proxy", proxy);
                f.WriteElementString("activarProxy", activarProxy);
                f.WriteElementString("GPparams", param);
                f.WriteStartElement("extensiones");

                foreach (string extension in extensiones)
                    f.WriteElementString("extension", extension);

                f.WriteEndElement();

                f.WriteStartElement("urls");

                foreach (string url in cUrls.Items)
                    if (url != ext)
                        f.WriteElementString("url", url);

                f.WriteEndElement();
                f.WriteEndDocument();
                f.Close();

                cUrl.Text = "";

                leerConfiguracion();
            }
        }

        private void leerConfiguracion()
        {
            // leemos el fichero de configuracin
            XmlDocument xDoc = new XmlDocument();
            xDoc.Load("config.xml");
            XmlNodeList nodoUrls = xDoc.GetElementsByTagName("urls");
            XmlNode nodoUrl = nodoUrls.Item(0);

            cUrls.Items.Clear();

            foreach (XmlElement nodo in nodoUrl)
                cUrls.Items.Add(nodo.InnerText);
        }        

        private void FormUrls_Load(object sender, EventArgs e)
        {
            foreach (string nodo in urls)
                cUrls.Items.Add(nodo);

            ConfiguraIdioma();
        }

        private void cUrl_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
                bAnadir_Click(sender, e);
        }

        private void ConfiguraIdioma()
        {
            if (Idioma == "es")
            {
                this.Text = "Filtrar Urls";
                label16.Text = "Urls a omitir en la depuracin:";
                label19.Text = "Aadir url:";
                bVolver.Text = "VOLVER";
            }
            else
            {
                this.Text = "Filter Urls";
                label16.Text = "Urls to ignore when capturing data:";
                label19.Text = "Add url:";
                bVolver.Text = "BACK";
            }
        }
    }
}