using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Web.UI;

namespace WindowsProxy
{
    public partial class FormViewState : Form
    {
        public FormViewState()
        {
            InitializeComponent();
        }

        String vstate;
        String idioma;

        public String Idioma
        {
            get { return idioma; }
            set { idioma = value; }
        }

        public String Vstate
        {
            get { return vstate; }
            set { vstate = value; }
        }

        private void bVolver_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void FormViewState_Load(object sender, EventArgs e)
        {
            cVSEntrada.Text = vstate;

            ConfiguraIdioma();
        }

        private void bDecode_Click(object sender, EventArgs e)
        {
            if (cVSEntrada.Text == "")
            {
                if (idioma == "es")
                    MessageBox.Show("Debes escribir el valor de ViewState", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                else
                    MessageBox.Show("You have to write ViewState value", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
            else
                DesencriptarVS();
        }

        private void DesencriptarVS()
        {
            try
            {
                XmlDocument document;
                LosFormatter formatter = new LosFormatter();
                XmlDocument dom = ViewState.BuildXml(formatter.Deserialize(cVSEntrada.Text), out document);
                StringBuilder sb = new StringBuilder();
                StringWriter writer = new StringWriter(sb);
                dom.Save(writer);
                cViewState.Text = writer.ToString();

                sb = new StringBuilder();
                writer = new StringWriter(sb);
                document.Save(writer);
                cControlState.Text = writer.ToString();
            }
            catch 
            {
                if (idioma == "es")
                    MessageBox.Show("No se ha podido decodificar ViewState", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                else
                    MessageBox.Show("Is not possible to decode ViewState", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void ConfiguraIdioma()
        {
            if (Idioma == "es")
            {
                this.Text = "Decodificar ViewState";
                bVolver.Text = "VOLVER";
            }
            else
            {
                this.Text = "ViewState decode";
                bVolver.Text = "BACK";
            }
        }
    }
}